<template>
    <!-- 广告位管理 -->
    <div>
        <!-- 头部搜索框部分 -->
        <div class="title">
            <el-row>
                <el-col :span="6" class="left">
                    <div class="searchBox">
                        <div class="searchTitle">网站名称</div>
                        <el-input v-model="webSiteName_name" class="input" placeholder="请输入网站名称"></el-input>
                        <!-- <el-select v-model="webSiteName_id" :multiple="false" :multiple-limit="1" filterable remote
                            reserve-keyword placeholder="请输入网站名称" :remote-method="getWebNavList"
                            :loading="webSiteLoading" @change="selectWebSite">
                            <el-option v-for="item in webSiteList" :key="item.value" :label="item.label"
                                :value="item.value">
                            </el-option>
                        </el-select> -->
                    </div>
                </el-col>
                <el-col :span="6" class="left">
                    <div class="searchBox">
                        <div class="searchTitle">底部导航名称</div>
                        <el-input v-model="tabbarName" class="input" placeholder="请输入底部导航名称"></el-input>
                    </div>
                </el-col>
                <el-col :span="8" class="right">
                    <div class="btnList">
                        <button class="search" @click="goSearch">搜索</button>
                        <button class="reset" @click="goReset">重置</button>
                    </div>
                </el-col>
            </el-row>
        </div>
        <!--表格内容 start------------------------------------------------------------>
        <div class="layerBox">
            <tableTitle :name="tableDivTitle" />
            <button class="btn" @click="addWebsite">添加底部导航</button>
            <el-row>
                <template>
                    <el-table class="my-table" :data="tableData" style="width: 100%">
                        <el-table-column fixed prop="id" label="编号" width="90">
                        </el-table-column>
                        <el-table-column prop="website_name" label="网站" width="">
                        </el-table-column>
                        <el-table-column prop="name" label="底部导航名称" width="">
                        </el-table-column>
                        <el-table-column prop="created_at" label="添加时间" width="">
                        </el-table-column>
                        <el-table-column prop="updated_at" label="修改时间" width="">
                        </el-table-column>
                        <el-table-column fixed="right" label="操作" width="300">
                            <template slot-scope="scope">
                                <div class="listBtnBox">
                                    <div class="listDeleteBtn" @click="deleteRow(scope.row.id)">
                                        <i class="el-icon-delete"></i>
                                        删除
                                    </div>
                                    <div class="listEditBtn" @click="goEdit(scope.row.id, scope.row)">
                                        <i class="el-icon-edit-outline"></i>
                                        编辑
                                    </div>
                                    <div class="listLookBtn" @click="goLook(scope.row.id,scope.row)">
                                        <i class="el-icon-view"></i>
                                        查看
                                    </div>
                                </div>
                            </template>
                        </el-table-column>
                    </el-table>
                </template>
            </el-row>
        </div>
        <!--分页 start------------------------------------------------------------>
        <div class="alignBox">
            <el-row>
                <el-col :span="24">
                    <el-pagination background @size-change="handleSizeChange" @current-change="handleCurrentChange"
                        :current-page="page" :page-size="pageSize" layout="total, prev, pager, next, jumper"
                        :total="total">
                    </el-pagination>
                </el-col>
            </el-row>
        </div>
        <!--分页 end------------------------------------------------------------>
        <!--表格内容 end------------------------------------------------------------>

        <!-- 弹出框 编辑 start----------------------------------------------------------->
        <el-dialog :title="dialogName" :visible.sync="dialogTableVisible" width="50%" top="8vh"
            :close-on-click-modal="false">
            <el-form :model="ruleForm" :rules="rules" ref="ruleForm" label-width="120px" class="demo-ruleForm">
                <div class="dialogText">
                    <el-form-item label="关联网站名称:" prop="webName">
                        <el-select v-model="ruleForm.webName" :multiple="false" :multiple-limit="1" filterable remote
                            reserve-keyword placeholder="请输入关联网站名称" :remote-method="getWebNavList"
                            :loading="webSiteLoading" @change="detectionWebSite">
                            <el-option v-for="item in webSiteList" :key="item.value" :label="item.label"
                                :value="item.value">
                            </el-option>
                        </el-select>
                    </el-form-item>
                    <el-form-item label="底部导航名称:" prop="tabbarName">
                        <el-input v-model="ruleForm.tabbarName" placeholder="请输入底部导航名称"></el-input>
                    </el-form-item>
                    <el-form-item label="页面类型:" prop="pageType">
                        <el-radio v-model="ruleForm.pageType" label="1" :disabled="this.disabled">特殊列表页</el-radio>
                        <el-radio v-model="ruleForm.pageType" label="0" :disabled="this.disabled">特殊详情页</el-radio>
                    </el-form-item>
                </div>
                <div class="dialogBtn">
                    <el-button type="info" @click="cancelForm">取消</el-button>
                    <el-button type="primary" @click="submitForm('ruleForm')">提交</el-button>
                </div>
            </el-form>
        </el-dialog>
        <!-- 弹出框 编辑 end----------------------------------------------------------->
    </div>
</template>

<script>
//表格标题
import tableTitle from './components/tableTitle.vue';

//引入公用样式
import '@/styles/global.less';
import { getFooterCategory, getTemplateClass, upFooterCategory, delFooterCategory } from '@/api/tabbar'
export default {
    components: {
        tableTitle,//表格标题-
    },
    data() {
        const validateEmpty = (rule, value, callback) => {
            if (value.length == 0) {
                callback(new Error('该项不能为空！'))
            } else {
                callback()
            }
        }
        return {
            tableDivTitle: "底部导航列表",  //列表标题
            dialogTableVisible: false,      //编辑弹框
            dialogName: '编辑', //编辑弹窗名称
            disabled: false, //禁用

            tableData: [],//表格数据

            // 可以输入的搜索框相关
            webSiteList: [],//获取关联网站列表
            webSiteLoading: false,

            //3.4 上传logo图片
            logoUrl: '',
            hovering: false, // 鼠标悬浮状态 悬浮时显示删除

            value: '',

            
            activeid: "",  //活动id 
            type:"",  //查看时需要传递的类型

            // 分页相关
            page: 1,
            pageSize: 10,
            total: 0,


            formLabelWidth: '', //广告示例图相关


            // 搜索框相关
            webSiteName_name: '', //网站名称
            webSiteName_id: '', //网站名称id
            tabbarName: '', //底部导航名称
            website_id: "", //网站id


            ruleForm: {
                webName: '', //网站名称
                tabbarName: '', //底部导航名称
                pageType: '', //页面类型
            },
            rules: {
                webName: [{ required: true, trigger: 'blur', validator: validateEmpty }],
                tabbarName: [{ required: true, trigger: 'blur', validator: validateEmpty }],
                pageType: [{ required: true, trigger: 'blur', validator: validateEmpty }],
            }
        }
    },
    methods: {
        //1.列表和分页相关 start ------------------------------------------------------------>
        //1.1 开始请求列表信息方法
        getData() {
            getFooterCategory({
                page: this.page,
                pageSize: this.pageSize
            }).then(data => {
                console.log(data);
                this.tableData = data.data.rows
                this.total = data.data.count
            })
        },

        //1.2 删除内容
        deleteRow(id) {
            console.log(id);
            let data = new FormData()
            data.append('id', id)
            this.$confirm('注意:删除后，该条信息及其绑定关系全部删除', '是否确认删除该条信息？', {
                confirmButtonText: '确定',
                cancelButtonText: '取消',
            }).then(() => {
                console.log("当前删除：" + id)

                delFooterCategory({
                    id: id
                }).then(data => {
                    console.log(data);
                    if (data.code = 200) {
                        this.$message({
                            message: '删除成功',
                            type: 'success'
                        })
                        this.getData()
                    } else if (data.code == 0) {
                        this.$message({
                            message: data.message,
                            type: 'error'
                        })
                    }
                })

            }).catch(() => {
                this.$message({
                    type: 'warning',
                    message: '已取消删除'
                });
            });
        },
        //1.3 查看示例图
        goGraph() {
            this.dialogVisible = true
        },

        //1.4 列表内容分页
        //直接跳转
        handleSizeChange(val) {
            this.page = val;
            this.getData();
        },
        //1.5 点击分页
        handleCurrentChange(val) {
            this.page = val;
            this.getData();
        },
        // 1.6 搜索按钮
        goSearch() {
            if (this.webSiteName_name && this.tabbarName) {
                getFooterCategory({
                    page: this.page,
                    pageSize: this.pageSize,
                    name: this.tabbarName,
                    website_name: this.webSiteName_name, //网站名称
                }).then(data => {
                    console.log(data);
                    this.tableData = data.data.rows
                    this.total = data.data.count
                })
            } else if (this.webSiteName_name && !this.tabbarName) {
                getFooterCategory({
                    page: this.page,
                    pageSize: this.pageSize,
                    // name: this.tabbarName,
                    website_name: this.webSiteName_name, //网站名称
                }).then(data => {
                    console.log(data);
                    this.tableData = data.data.rows
                    this.total = data.data.count
                })
            } else if (!this.webSiteName_name && this.tabbarName) {
                getFooterCategory({
                    page: this.page,
                    pageSize: this.pageSize,
                    name: this.tabbarName,
                    // website_name: this.webSiteName_name, //网站名称
                }).then(data => {
                    console.log(data);
                    this.tableData = data.data.rows
                    this.total = data.data.count
                })
            }

        },
        //1.7 重置按钮
        goReset() {
            this.webSiteName_name = ""
            this.tabbarName = ""
            this.getData()
        },
        //列表和分页相关 end ------------------------------------------------------------>

        //1.9 编辑
        goEdit(id, val) {
            // console.log(id);
            this.dialogName = '编辑'
            this.activeid = id
            this.dialogTableVisible = true
            this.disabled=true
            console.log(id, val);
            console.log("状态", val);

            //数据回显
            this.website_id = val.website_id
            this.ruleForm.webName = val.website_name //网站名称
            this.ruleForm.tabbarName = val.name //底部导航名称
            if (val.type == 0) {
                this.ruleForm.pageType = '0' //页面类型
            } else if (val.type == 1) {
                this.ruleForm.pageType = '1' //页面类型
            }
        },

        //2.0 查看
        goLook(id,val) {
            this.activeid = id
            this.type=val.type
            this.$router.push({
                path: '/tabbarDetail',
                query: {
                    id: this.activeid,
                    type:this.type
                }
            })
        },

        //1.7 添加
        addWebsite() {
            this.dialogTableVisible = true
            this.dialogName = "添加"
            this.disabled=false

            //添加时清空回显回来的数据
            this.ruleForm.webName = '' //关联网站名称
            this.ruleForm.tabbarName = '' //底部导航名称
            this.ruleForm.pageType = '' //页面类型
        },

        // 弹出层相关方法
        // 提交表单
        submitForm(formName) {
            this.$refs[formName].validate((valid) => {
                if (valid) {
                    console.log('submit!');

                } else {
                    console.log('error submit!!');
                    return false;
                }
            });
            if (this.dialogName == "添加") {
                getTemplateClass({
                    website_id: this.website_id,
                    name: this.ruleForm.tabbarName,
                    type: this.ruleForm.pageType,
                }).then(data => {
                    console.log(data);
                    if (data.code == 200) {
                        this.$message({
                            message: '添加成功',
                            type: 'success'
                        })
                        this.dialogTableVisible = false
                        this.getData()
                    } else if (data.code == 0) {
                        this.$message({
                            message: data.message,
                            type: 'error'
                        })
                        this.dialogTableVisible = true
                        return
                    } else {
                        this.$message({
                            message: data.message,
                            type: 'error'
                        })
                        this.dialogTableVisible = true
                        return
                    }
                })
            }
            if (this.website_id == '') {
                this.$message({
                    message: '请输入并选择网站名称',
                    type: 'error'
                })
                this.dialogVisible = true
            }
            if (this.dialogName == "编辑") {
                upFooterCategory({
                    website_id: this.website_id,
                    name: this.ruleForm.tabbarName,
                    id: this.activeid
                }).then(data => {
                    console.log(data);
                    if (data.code == 200) {
                        this.$message({
                            message: '编辑成功',
                            type: 'success'
                        })
                        this.dialogTableVisible = false
                    }
                    if (data.code == 0) {
                        this.$message({
                            message: data.message,
                            type: 'error'
                        })
                        this.dialogTableVisible = true
                    }
                    this.getData()
                })
            }

        },
        //取消添加或编辑
        cancelForm() {
            this.dialogTableVisible = false
        },
        //3.6 上传图片操作
        beforeAvatarUpload(file) {
            const isJPG = file.type === 'image/jpeg';
            const isPNG = file.type === 'image/png';
            const isLt2M = file.size / 1024 / 1024 < 2;

            if (!isJPG && !isPNG) {
                this.$message.error('上传图片只能是 JPG 或 PNG 格式!');
                return false;
            }
            if (!isLt2M) {
                this.$message.error('上传图片大小不能超过 2MB!');
                return false;
            }

            const formData = new FormData();
            formData.append('file', file);

            this.$store.dispatch('pool/uploadFile', formData).then(res => {
                this.logoUrl = res.data.imgUrl;//显示缩略图
                this.ruleForm.adPhoto = res.data.imgUrl;//提供表单地址
                console.log(res.data.imgUrl)
            }).catch(() => {
                this.$message({
                    type: 'info',
                    message: '网络错误，请重试！'
                });
            })

            // 阻止默认的上传行为
            return false;
        },
        handleDelete() {
            // 删除图片
            this.logoUrl = ''; // 清空图片 URL
        },

        //搜索部分的输入关键词下拉框
        selectWebSite(value) {
            this.webSiteName_id = value
        },

        //添加 / 编辑弹窗中输入关键词下拉框 
        // 判断是否已经关联了网站
        detectionWebSite(value) {
            console.log(value);
            this.website_id = value
            console.log(this.website_id);

        },

        //
        getWebNavList(query) {
            if (query !== '') {
                this.webSiteLoading = true;
                let data = { keyword: query }
                let dataArr = [];
                this.$store.dispatch('pool/getNavWebList', data).then(res => {
                    console.log(res.data)
                    for (let item of res.data) {
                        let data = {};
                        data.key = item.id;
                        data.value = item.id;
                        data.label = item.website_name;
                        dataArr.push(data)
                    }
                    this.webSiteList = dataArr;
                    this.webSiteLoading = false;
                }).catch(() => {
                    this.$message({
                        type: 'info',
                        message: '网络错误，请重试！'
                    });
                })
            } else {
                this.navList = [];
            }
        },
    },
    mounted() {
        this.getData()
    },
}
</script>

<style scoped lang="less">
input[aria-hidden=true] {
    display: none !important;
}

// 提示信息
.tips {
    margin: 30px;
    background-color: #e9ecf9;
    border-radius: 11px;

    .tipsIcon {
        margin: 10px 15px;
        display: inline-block;
        width: 24px;
        height: 24px;
        background: url("../../assets/advertise/Info Circle.png") no-repeat;
        vertical-align: middle;
    }

    .tipsText {
        font-size: 14px;
        color: #666666;
    }
}

// 头部
.title {
    margin: 30px 30px 20px 30px;
    padding: 30px 30px 40px 30px;
    background-color: #fff;
    border-radius: 20px 20px 20px 20px;
    border: 1px solid #E9EDF7;

    .left {
        float: left;
    }

    .right {
        float: right;
    }


    .searchBox {
        ::v-deep .el-input {
            position: relative;
            font-size: 14px;
            display: inline-block;
            width: 80%;
        }

        .searchTitle {
            padding-bottom: 10px;
            font-family: Microsoft YaHei, Microsoft YaHei;
            font-weight: 400;
            font-size: 14px;
            color: #999999;
            line-height: 16px;
        }

        .el-select {
            width: 100%;
            display: inline-block;
            position: relative;
        }
    }


    .btnList {
        float: right;
        padding-top: 28px;

        button {
            height: 38px;
            border: none;
            border-radius: 8px;
            padding: 0 30px;
        }

        .search {
            background-color: #5570f1;
            color: #fff;
            margin-right: 20px;
        }

        .reset {
            font-family: Microsoft YaHei, Microsoft YaHei;
            font-weight: 400;
            font-size: 16px;
            color: #333333;
            background: #F5F7FB;
            border-radius: 8px 8px 8px 8px;
            border: 1px solid rgba(85, 112, 241, 0.11);
        }
    }
}

.layerBox {
    padding: 30px 20px;
    position: relative;

    .btn {
        position: absolute;
        top: 30px;
        right: 20px;
        height: 38px;
        color: #fff;
        background-color: #5570f1;
        border: none;
        border-radius: 8px;
        padding: 8px 28px 9px;
        box-sizing: border-box;
    }

    .listBtnBox {
        justify-content: left;
    }


    .listDeleteBtn,
    .listEditBtn,
    .listLookBtn {
        margin-left: 0px;
        padding-left: 0px;
        margin-right: 20px;
        width: 76px;
        height: 36px;
        line-height: 36px;
    }


    .listLookBtn {
        text-align: center;
        border-radius: 8px;
        cursor: pointer;
        color: #55b5f1;
        background-color: rgba(85, 181, 241, 0.16);

        >i {
            padding-right: 8px;
        }
    }

    ::v-deep .el-form-item {
        margin-bottom: 50px;
    }

    ::v-deep .el-select {
        width: 100%;
    }

    ::v-deep .el-input--medium,
    ::v-deep .el-form-item__label {
        line-height: 36px;
        font-size: 16px;
    }
}

// 弹出层内容
.dialogText {
    margin: 0 7px 0 3px;
    padding-bottom: 1px;
    padding: 30px 60px 1px 20px;
    background-color: #f5f7fb;

    .adImage {
        width: 140px;
        height: 140px;
        line-height: 210px;
        border-radius: 12px;
        border: 1px solid rgba(85, 112, 241, 0.11);

        img {
            width: 140px;
            height: 80px;
        }
    }



    ::v-deep .avatar {
        width: 140px;
        height: auto;
    }

    .price {
        ::v-deep .el-input {
            width: 29%;
        }
    }

    .example {
        font-family: Microsoft YaHei;
        color: #5570F1;
    }

    .el_btnList {
        margin-right: 15px;
        margin-top: 20px;
    }

    //日期时间选择器的宽
    ::v-deep .el-date-editor.el-input {
        width: 48%;
    }

    ::v-deep .el-button+.el-button {
        margin-left: 0px;
    }

    ::v-deep .el-select {
        width: 100%;
    }

    ::v-deep .el-form-item {
        margin-bottom: 50px;
    }
}

// 弹出层按钮
.dialogBtn {
    text-align: center;
    margin: 50px auto 20px;

    button {
        width: 184px;
        padding: 16px;
        font-family: Microsoft YaHei, Microsoft YaHei;
        font-weight: 400;
        font-size: 20px;
        border: none;
        border-radius: 12px 12px 12px 12px;
    }

    // 取消
    .cancel {
        color: #333333;
        background-color: #f5f7fb;
        border: 2px solid rgba(85, 112, 241, 0.11);
    }

    // 提交
    .submit {
        color: #fff;
        background-color: #5570F1;
        margin-left: 40px;
    }
}

//审核弹出框
.radioGroup {
    ::v-deep .el-form-item {
        margin-top: 40px;
        margin-bottom: 0;
    }
}

.graph {
    background-color: #f5f7fb;
    padding: 60px 100px;
    overflow: hidden;

    li {
        float: left;
    }

    >li:first-child {
        margin-right: 100px;
    }
}

.dialog-footer {
    margin: 0 auto;
}
</style>